Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter_lib.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -1129,12 +954,9 @@
 		goto end;
 	twitter_xt_get_status_list(ic, parsed, txl);
-	json_value_free(parsed);
+	xt_free_node(parsed);
 
 	td->mentions_obj = txl;
 
       end:
-	if (!g_slist_find(twitter_connections, ic))
-		return;
-
 	td->flags |= TWITTER_GOT_MENTIONS;
 
@@ -1150,5 +972,5 @@
 	struct im_connection *ic = req->data;
 	struct twitter_data *td;
-	json_value *parsed, *id;
+	struct xt_node *parsed, *node;
 
 	// Check if the connection is still active.
@@ -1162,12 +984,7 @@
 		return;
 	
-	if ((id = json_o_get(parsed, "id")) && id->type == json_integer) {
-		td->last_status_id = id->u.integer;
-	}
-	
-	json_value_free(parsed);
-	
-	if (req->flags & TWITTER_HTTP_USER_ACK)
-		twitter_log(ic, "Command processed successfully");
+	if ((node = xt_find_node(parsed, "status")) &&
+	    (node = xt_find_node(node->children, "id")) && node->text)
+		td->last_status_id = g_ascii_strtoull(node->text, NULL, 10);
 }
 
@@ -1215,7 +1032,6 @@
 	char *url;
 	url = g_strdup_printf("%s%llu%s", TWITTER_STATUS_DESTROY_URL,
-	                      (unsigned long long) id, ".json");
-	twitter_http_f(ic, url, twitter_http_post, ic, 1, NULL, 0,
-	               TWITTER_HTTP_USER_ACK);
+	                      (unsigned long long) id, ".xml");
+	twitter_http(ic, url, twitter_http_post, ic, 1, NULL, 0);
 	g_free(url);
 }
@@ -1225,7 +1041,6 @@
 	char *url;
 	url = g_strdup_printf("%s%llu%s", TWITTER_STATUS_RETWEET_URL,
-	                      (unsigned long long) id, ".json");
-	twitter_http_f(ic, url, twitter_http_post, ic, 1, NULL, 0,
-	               TWITTER_HTTP_USER_ACK);
+	                      (unsigned long long) id, ".xml");
+	twitter_http(ic, url, twitter_http_post, ic, 1, NULL, 0);
 	g_free(url);
 }
@@ -1241,6 +1056,6 @@
 	};
 	args[1] = screen_name;
-	twitter_http_f(ic, TWITTER_REPORT_SPAM_URL, twitter_http_post,
-	               ic, 1, args, 2, TWITTER_HTTP_USER_ACK);
+	twitter_http(ic, TWITTER_REPORT_SPAM_URL, twitter_http_post,
+	             ic, 1, args, 2);
 }
 
@@ -1252,7 +1067,6 @@
 	char *url;
 	url = g_strdup_printf("%s%llu%s", TWITTER_FAVORITE_CREATE_URL,
-	                      (unsigned long long) id, ".json");
-	twitter_http_f(ic, url, twitter_http_post, ic, 1, NULL, 0,
-	               TWITTER_HTTP_USER_ACK);
+	                      (unsigned long long) id, ".xml");
+	twitter_http(ic, url, twitter_http_post, ic, 1, NULL, 0);
 	g_free(url);
 }
Index: protocols/twitter/twitter_lib.h
===================================================================
--- protocols/twitter/twitter_lib.h	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter_lib.h	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -29,9 +29,9 @@
 #include "twitter_http.h"
 
-#define TWITTER_API_URL "http://api.twitter.com/1.1"
+#define TWITTER_API_URL "http://api.twitter.com/1"
 #define IDENTICA_API_URL "https://identi.ca/api"
 
 /* Status URLs */
-#define TWITTER_STATUS_UPDATE_URL "/statuses/update.json"
+#define TWITTER_STATUS_UPDATE_URL "/statuses/update.xml"
 #define TWITTER_STATUS_SHOW_URL "/statuses/show/"
 #define TWITTER_STATUS_DESTROY_URL "/statuses/destroy/"
@@ -39,34 +39,34 @@
 
 /* Timeline URLs */
-#define TWITTER_PUBLIC_TIMELINE_URL "/statuses/public_timeline.json"
-#define TWITTER_FEATURED_USERS_URL "/statuses/featured.json"
-#define TWITTER_FRIENDS_TIMELINE_URL "/statuses/friends_timeline.json"
-#define TWITTER_HOME_TIMELINE_URL "/statuses/home_timeline.json"
-#define TWITTER_MENTIONS_URL "/statuses/mentions_timeline.json"
-#define TWITTER_USER_TIMELINE_URL "/statuses/user_timeline.json"
+#define TWITTER_PUBLIC_TIMELINE_URL "/statuses/public_timeline.xml"
+#define TWITTER_FEATURED_USERS_URL "/statuses/featured.xml"
+#define TWITTER_FRIENDS_TIMELINE_URL "/statuses/friends_timeline.xml"
+#define TWITTER_HOME_TIMELINE_URL "/statuses/home_timeline.xml"
+#define TWITTER_MENTIONS_URL "/statuses/mentions.xml"
+#define TWITTER_USER_TIMELINE_URL "/statuses/user_timeline.xml"
 
 /* Users URLs */
-#define TWITTER_USERS_LOOKUP_URL "/users/lookup.json"
+#define TWITTER_USERS_LOOKUP_URL "/users/lookup.xml"
 
 /* Direct messages URLs */
-#define TWITTER_DIRECT_MESSAGES_URL "/direct_messages.json"
-#define TWITTER_DIRECT_MESSAGES_NEW_URL "/direct_messages/new.json"
-#define TWITTER_DIRECT_MESSAGES_SENT_URL "/direct_messages/sent.json"
+#define TWITTER_DIRECT_MESSAGES_URL "/direct_messages.xml"
+#define TWITTER_DIRECT_MESSAGES_NEW_URL "/direct_messages/new.xml"
+#define TWITTER_DIRECT_MESSAGES_SENT_URL "/direct_messages/sent.xml"
 #define TWITTER_DIRECT_MESSAGES_DESTROY_URL "/direct_messages/destroy/"
 
 /* Friendships URLs */
-#define TWITTER_FRIENDSHIPS_CREATE_URL "/friendships/create.json"
-#define TWITTER_FRIENDSHIPS_DESTROY_URL "/friendships/destroy.json"
-#define TWITTER_FRIENDSHIPS_SHOW_URL "/friendships/show.json"
+#define TWITTER_FRIENDSHIPS_CREATE_URL "/friendships/create.xml"
+#define TWITTER_FRIENDSHIPS_DESTROY_URL "/friendships/destroy.xml"
+#define TWITTER_FRIENDSHIPS_SHOW_URL "/friendships/show.xml"
 
 /* Social graphs URLs */
-#define TWITTER_FRIENDS_IDS_URL "/friends/ids.json"
-#define TWITTER_FOLLOWERS_IDS_URL "/followers/ids.json"
+#define TWITTER_FRIENDS_IDS_URL "/friends/ids.xml"
+#define TWITTER_FOLLOWERS_IDS_URL "/followers/ids.xml"
 
 /* Account URLs */
-#define TWITTER_ACCOUNT_RATE_LIMIT_URL "/account/rate_limit_status.json"
+#define TWITTER_ACCOUNT_RATE_LIMIT_URL "/account/rate_limit_status.xml"
 
 /* Favorites URLs */
-#define TWITTER_FAVORITES_GET_URL "/favorites.json"
+#define TWITTER_FAVORITES_GET_URL "/favorites.xml"
 #define TWITTER_FAVORITE_CREATE_URL "/favorites/create/"
 #define TWITTER_FAVORITE_DESTROY_URL "/favorites/destroy/"
@@ -77,11 +77,10 @@
 
 /* Report spam */
-#define TWITTER_REPORT_SPAM_URL "/report_spam.json"
+#define TWITTER_REPORT_SPAM_URL "/report_spam.xml"
 
-#define TWITTER_USER_STREAM_URL "https://userstream.twitter.com/1.1/user.json"
-
-gboolean twitter_open_stream(struct im_connection *ic);
 void twitter_get_timeline(struct im_connection *ic, gint64 next_cursor);
 void twitter_get_friends_ids(struct im_connection *ic, gint64 next_cursor);
+void twitter_get_home_timeline(struct im_connection *ic, gint64 next_cursor);
+void twitter_get_mentions(struct im_connection *ic, gint64 next_cursor);
 void twitter_get_statuses_friends(struct im_connection *ic, gint64 next_cursor);
 
